"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = void 0;
const tslib_1 = require("tslib");
exports.validate = validate24;
exports.default = validate24;
const ucs2length_1 = tslib_1.__importDefault(require("@kubernetes-models/validate/runtime/ucs2length"));
const pattern0 = new RegExp("^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$", "u");
function validate21(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data && null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("string" == typeof data) {
    if ((0, ucs2length_1.default)(data) > 253) {
        const err1 = { instancePath, schemaPath: "#/maxLength", keyword: "maxLength", params: { limit: 253 }, message: "must NOT have more than 253 characters" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    if (!pattern0.test(data)) {
        const err2 = { instancePath, schemaPath: "#/pattern", keyword: "pattern", params: { pattern: "^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$" }, message: 'must match pattern "^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$"' };
        null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
    }
} return validate21.errors = vErrors, 0 === errors; }
const pattern1 = new RegExp("^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$", "u");
function validate22(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" == typeof data) {
    if ((0, ucs2length_1.default)(data) > 63) {
        const err0 = { instancePath, schemaPath: "#/maxLength", keyword: "maxLength", params: { limit: 63 }, message: "must NOT have more than 63 characters" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    if ((0, ucs2length_1.default)(data) < 1) {
        const err1 = { instancePath, schemaPath: "#/minLength", keyword: "minLength", params: { limit: 1 }, message: "must NOT have fewer than 1 characters" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    if (!pattern1.test(data)) {
        const err2 = { instancePath, schemaPath: "#/pattern", keyword: "pattern", params: { pattern: "^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$" }, message: 'must match pattern "^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$"' };
        null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
    }
}
else {
    const err3 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err3] : vErrors.push(err3), errors++;
} return validate22.errors = vErrors, 0 === errors; }
function validate23(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" == typeof data) {
    if ((0, ucs2length_1.default)(data) > 253) {
        const err0 = { instancePath, schemaPath: "#/maxLength", keyword: "maxLength", params: { limit: 253 }, message: "must NOT have more than 253 characters" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    if ((0, ucs2length_1.default)(data) < 1) {
        const err1 = { instancePath, schemaPath: "#/minLength", keyword: "minLength", params: { limit: 1 }, message: "must NOT have fewer than 1 characters" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
}
else {
    const err2 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
} return validate23.errors = vErrors, 0 === errors; }
function validate26(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (data && "object" == typeof data && !Array.isArray(data)) {
    if (void 0 === data.kind) {
        const err0 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "kind" }, message: "must have required property 'kind'" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    if (void 0 === data.name) {
        const err1 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "name" }, message: "must have required property 'name'" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    void 0 !== data.group && (validate21(data.group, { instancePath: instancePath + "/group", parentData: data, parentDataProperty: "group", rootData }) || (vErrors = null === vErrors ? validate21.errors : vErrors.concat(validate21.errors), errors = vErrors.length)), void 0 !== data.kind && (validate22(data.kind, { instancePath: instancePath + "/kind", parentData: data, parentDataProperty: "kind", rootData }) || (vErrors = null === vErrors ? validate22.errors : vErrors.concat(validate22.errors), errors = vErrors.length)), void 0 !== data.name && (validate23(data.name, { instancePath: instancePath + "/name", parentData: data, parentDataProperty: "name", rootData }) || (vErrors = null === vErrors ? validate23.errors : vErrors.concat(validate23.errors), errors = vErrors.length));
}
else {
    const err2 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" };
    null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
} return validate26.errors = vErrors, 0 === errors; }
function validate36(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data && null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("string" == typeof data && (0, ucs2length_1.default)(data) > 253) {
    const err1 = { instancePath, schemaPath: "#/maxLength", keyword: "maxLength", params: { limit: 253 }, message: "must NOT have more than 253 characters" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate36.errors = vErrors, 0 === errors; }
function validate32(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (data && "object" == typeof data && !Array.isArray(data)) {
    if (void 0 === data.kind) {
        const err0 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "kind" }, message: "must have required property 'kind'" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    if (void 0 === data.name) {
        const err1 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "name" }, message: "must have required property 'name'" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    void 0 !== data.group && (validate21(data.group, { instancePath: instancePath + "/group", parentData: data, parentDataProperty: "group", rootData }) || (vErrors = null === vErrors ? validate21.errors : vErrors.concat(validate21.errors), errors = vErrors.length)), void 0 !== data.kind && (validate22(data.kind, { instancePath: instancePath + "/kind", parentData: data, parentDataProperty: "kind", rootData }) || (vErrors = null === vErrors ? validate22.errors : vErrors.concat(validate22.errors), errors = vErrors.length)), void 0 !== data.name && (validate23(data.name, { instancePath: instancePath + "/name", parentData: data, parentDataProperty: "name", rootData }) || (vErrors = null === vErrors ? validate23.errors : vErrors.concat(validate23.errors), errors = vErrors.length)), void 0 !== data.namespace && (validate36(data.namespace, { instancePath: instancePath + "/namespace", parentData: data, parentDataProperty: "namespace", rootData }) || (vErrors = null === vErrors ? validate36.errors : vErrors.concat(validate36.errors), errors = vErrors.length));
}
else {
    const err2 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" };
    null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
} return validate32.errors = vErrors, 0 === errors; }
function validate31(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (Array.isArray(data)) {
    const len0 = data.length;
    for (let i0 = 0; i0 < len0; i0++)
        validate32(data[i0], { instancePath: instancePath + "/" + i0, parentData: data, parentDataProperty: i0, rootData }) || (vErrors = null === vErrors ? validate32.errors : vErrors.concat(validate32.errors), errors = vErrors.length);
}
else {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "array" }, message: "must be array" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} return validate31.errors = vErrors, 0 === errors; }
function validate25(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (data && "object" == typeof data && !Array.isArray(data)) {
    if (void 0 === data.targetRef) {
        const err0 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "targetRef" }, message: "must have required property 'targetRef'" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    if (void 0 === data.requiredAuthenticationRefs) {
        const err1 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "requiredAuthenticationRefs" }, message: "must have required property 'requiredAuthenticationRefs'" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    void 0 !== data.targetRef && (validate26(data.targetRef, { instancePath: instancePath + "/targetRef", parentData: data, parentDataProperty: "targetRef", rootData }) || (vErrors = null === vErrors ? validate26.errors : vErrors.concat(validate26.errors), errors = vErrors.length)), void 0 !== data.requiredAuthenticationRefs && (validate31(data.requiredAuthenticationRefs, { instancePath: instancePath + "/requiredAuthenticationRefs", parentData: data, parentDataProperty: "requiredAuthenticationRefs", rootData }) || (vErrors = null === vErrors ? validate31.errors : vErrors.concat(validate31.errors), errors = vErrors.length));
}
else {
    const err2 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" };
    null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
} return validate25.errors = vErrors, 0 === errors; }
const schema15 = { type: "string", enum: ["policy.linkerd.io/v1alpha1"] };
function validate41(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("policy.linkerd.io/v1alpha1" !== data) {
    const err1 = { instancePath, schemaPath: "#/enum", keyword: "enum", params: { allowedValues: schema15.enum }, message: "must be equal to one of the allowed values" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate41.errors = vErrors, 0 === errors; }
const schema16 = { type: "string", enum: ["AuthorizationPolicy"] };
function validate43(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("AuthorizationPolicy" !== data) {
    const err1 = { instancePath, schemaPath: "#/enum", keyword: "enum", params: { allowedValues: schema16.enum }, message: "must be equal to one of the allowed values" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate43.errors = vErrors, 0 === errors; }
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = tslib_1.__importDefault(require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta"));
function validate46(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; return (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.default)(data, { instancePath, parentData, parentDataProperty, rootData }) || (vErrors = null === vErrors ? IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.default.errors : vErrors.concat(IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.default.errors), errors = vErrors.length), validate46.errors = vErrors, 0 === errors; }
function validate50(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "null" }, message: "must be null" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} return validate50.errors = vErrors, 0 === errors; }
function validate45(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; const _errs0 = errors; let valid0 = !1, passing0 = null; const _errs1 = errors; validate46(data, { instancePath, parentData, parentDataProperty, rootData }) || (vErrors = null === vErrors ? validate46.errors : vErrors.concat(validate46.errors), errors = vErrors.length), (_valid0 = _errs1 === errors) && (valid0 = !0, passing0 = 0); const _errs2 = errors; var _valid0; if (validate50(data, { instancePath, parentData, parentDataProperty, rootData }) || (vErrors = null === vErrors ? validate50.errors : vErrors.concat(validate50.errors), errors = vErrors.length), (_valid0 = _errs2 === errors) && valid0 ? (valid0 = !1, passing0 = [passing0, 1]) : _valid0 && (valid0 = !0, passing0 = 1), valid0)
    errors = _errs0, null !== vErrors && (_errs0 ? vErrors.length = _errs0 : vErrors = null);
else {
    const err0 = { instancePath, schemaPath: "#/oneOf", keyword: "oneOf", params: { passingSchemas: passing0 }, message: "must match exactly one schema in oneOf" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} return validate45.errors = vErrors, 0 === errors; }
function validate24(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (data && "object" == typeof data && !Array.isArray(data)) {
    if (void 0 === data.spec) {
        const err0 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "spec" }, message: "must have required property 'spec'" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    if (void 0 === data.apiVersion) {
        const err1 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "apiVersion" }, message: "must have required property 'apiVersion'" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    if (void 0 === data.kind) {
        const err2 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "kind" }, message: "must have required property 'kind'" };
        null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
    }
    void 0 !== data.spec && (validate25(data.spec, { instancePath: instancePath + "/spec", parentData: data, parentDataProperty: "spec", rootData }) || (vErrors = null === vErrors ? validate25.errors : vErrors.concat(validate25.errors), errors = vErrors.length)), void 0 !== data.apiVersion && (validate41(data.apiVersion, { instancePath: instancePath + "/apiVersion", parentData: data, parentDataProperty: "apiVersion", rootData }) || (vErrors = null === vErrors ? validate41.errors : vErrors.concat(validate41.errors), errors = vErrors.length)), void 0 !== data.kind && (validate43(data.kind, { instancePath: instancePath + "/kind", parentData: data, parentDataProperty: "kind", rootData }) || (vErrors = null === vErrors ? validate43.errors : vErrors.concat(validate43.errors), errors = vErrors.length)), void 0 !== data.metadata && (validate45(data.metadata, { instancePath: instancePath + "/metadata", parentData: data, parentDataProperty: "metadata", rootData }) || (vErrors = null === vErrors ? validate45.errors : vErrors.concat(validate45.errors), errors = vErrors.length));
}
else {
    const err3 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" };
    null === vErrors ? vErrors = [err3] : vErrors.push(err3), errors++;
} return validate24.errors = vErrors, 0 === errors; }
