"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = void 0;
const tslib_1 = require("tslib");
exports.validate = validate21;
exports.default = validate21;
function validate23(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (data && "object" == typeof data && !Array.isArray(data) && void 0 === data.identities) {
    const err0 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "identities" }, message: "must have required property 'identities'" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} return validate23.errors = vErrors, 0 === errors; }
function validate25(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (data && "object" == typeof data && !Array.isArray(data) && void 0 === data.identityRefs) {
    const err0 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "identityRefs" }, message: "must have required property 'identityRefs'" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} return validate25.errors = vErrors, 0 === errors; }
const pattern0 = new RegExp("^(\\*|[a-z0-9]([-a-z0-9]*[a-z0-9])?)(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$", "u");
function validate28(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" == typeof data) {
    if (!pattern0.test(data)) {
        const err0 = { instancePath, schemaPath: "#/pattern", keyword: "pattern", params: { pattern: "^(\\*|[a-z0-9]([-a-z0-9]*[a-z0-9])?)(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$" }, message: 'must match pattern "^(\\*|[a-z0-9]([-a-z0-9]*[a-z0-9])?)(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$"' };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
}
else {
    const err1 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate28.errors = vErrors, 0 === errors; }
function validate27(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (!Array.isArray(data) && null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "array" }, message: "must be array" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if (Array.isArray(data)) {
    if (data.length < 1) {
        const err1 = { instancePath, schemaPath: "#/minItems", keyword: "minItems", params: { limit: 1 }, message: "must NOT have fewer than 1 items" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    const len0 = data.length;
    for (let i0 = 0; i0 < len0; i0++)
        validate28(data[i0], { instancePath: instancePath + "/" + i0, parentData: data, parentDataProperty: i0, rootData }) || (vErrors = null === vErrors ? validate28.errors : vErrors.concat(validate28.errors), errors = vErrors.length);
} return validate27.errors = vErrors, 0 === errors; }
const ucs2length_1 = tslib_1.__importDefault(require("@kubernetes-models/validate/runtime/ucs2length"));
const pattern1 = new RegExp("^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$", "u");
function validate33(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data && null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("string" == typeof data) {
    if ((0, ucs2length_1.default)(data) > 253) {
        const err1 = { instancePath, schemaPath: "#/maxLength", keyword: "maxLength", params: { limit: 253 }, message: "must NOT have more than 253 characters" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    if (!pattern1.test(data)) {
        const err2 = { instancePath, schemaPath: "#/pattern", keyword: "pattern", params: { pattern: "^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$" }, message: 'must match pattern "^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$"' };
        null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
    }
} return validate33.errors = vErrors, 0 === errors; }
const pattern2 = new RegExp("^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$", "u");
function validate35(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" == typeof data) {
    if ((0, ucs2length_1.default)(data) > 63) {
        const err0 = { instancePath, schemaPath: "#/maxLength", keyword: "maxLength", params: { limit: 63 }, message: "must NOT have more than 63 characters" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    if ((0, ucs2length_1.default)(data) < 1) {
        const err1 = { instancePath, schemaPath: "#/minLength", keyword: "minLength", params: { limit: 1 }, message: "must NOT have fewer than 1 characters" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    if (!pattern2.test(data)) {
        const err2 = { instancePath, schemaPath: "#/pattern", keyword: "pattern", params: { pattern: "^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$" }, message: 'must match pattern "^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$"' };
        null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
    }
}
else {
    const err3 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err3] : vErrors.push(err3), errors++;
} return validate35.errors = vErrors, 0 === errors; }
function validate37(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data && null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("string" == typeof data) {
    if ((0, ucs2length_1.default)(data) > 253) {
        const err1 = { instancePath, schemaPath: "#/maxLength", keyword: "maxLength", params: { limit: 253 }, message: "must NOT have more than 253 characters" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    if ((0, ucs2length_1.default)(data) < 1) {
        const err2 = { instancePath, schemaPath: "#/minLength", keyword: "minLength", params: { limit: 1 }, message: "must NOT have fewer than 1 characters" };
        null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
    }
} return validate37.errors = vErrors, 0 === errors; }
function validate39(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data && null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("string" == typeof data && (0, ucs2length_1.default)(data) > 253) {
    const err1 = { instancePath, schemaPath: "#/maxLength", keyword: "maxLength", params: { limit: 253 }, message: "must NOT have more than 253 characters" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate39.errors = vErrors, 0 === errors; }
function validate32(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (data && "object" == typeof data && !Array.isArray(data)) {
    if (void 0 === data.kind) {
        const err0 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "kind" }, message: "must have required property 'kind'" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    void 0 !== data.group && (validate33(data.group, { instancePath: instancePath + "/group", parentData: data, parentDataProperty: "group", rootData }) || (vErrors = null === vErrors ? validate33.errors : vErrors.concat(validate33.errors), errors = vErrors.length)), void 0 !== data.kind && (validate35(data.kind, { instancePath: instancePath + "/kind", parentData: data, parentDataProperty: "kind", rootData }) || (vErrors = null === vErrors ? validate35.errors : vErrors.concat(validate35.errors), errors = vErrors.length)), void 0 !== data.name && (validate37(data.name, { instancePath: instancePath + "/name", parentData: data, parentDataProperty: "name", rootData }) || (vErrors = null === vErrors ? validate37.errors : vErrors.concat(validate37.errors), errors = vErrors.length)), void 0 !== data.namespace && (validate39(data.namespace, { instancePath: instancePath + "/namespace", parentData: data, parentDataProperty: "namespace", rootData }) || (vErrors = null === vErrors ? validate39.errors : vErrors.concat(validate39.errors), errors = vErrors.length));
}
else {
    const err1 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate32.errors = vErrors, 0 === errors; }
function validate31(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (!Array.isArray(data) && null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "array" }, message: "must be array" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if (Array.isArray(data)) {
    if (data.length < 1) {
        const err1 = { instancePath, schemaPath: "#/minItems", keyword: "minItems", params: { limit: 1 }, message: "must NOT have fewer than 1 items" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    const len0 = data.length;
    for (let i0 = 0; i0 < len0; i0++)
        validate32(data[i0], { instancePath: instancePath + "/" + i0, parentData: data, parentDataProperty: i0, rootData }) || (vErrors = null === vErrors ? validate32.errors : vErrors.concat(validate32.errors), errors = vErrors.length);
} return validate31.errors = vErrors, 0 === errors; }
function validate22(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; const _errs1 = errors; let valid0 = !1, passing0 = null; const _errs2 = errors; validate23(data, { instancePath, parentData, parentDataProperty, rootData }) || (vErrors = null === vErrors ? validate23.errors : vErrors.concat(validate23.errors), errors = vErrors.length), (_valid0 = _errs2 === errors) && (valid0 = !0, passing0 = 0); const _errs3 = errors; var _valid0; if (validate25(data, { instancePath, parentData, parentDataProperty, rootData }) || (vErrors = null === vErrors ? validate25.errors : vErrors.concat(validate25.errors), errors = vErrors.length), (_valid0 = _errs3 === errors) && valid0 ? (valid0 = !1, passing0 = [passing0, 1]) : _valid0 && (valid0 = !0, passing0 = 1), valid0)
    errors = _errs1, null !== vErrors && (_errs1 ? vErrors.length = _errs1 : vErrors = null);
else {
    const err0 = { instancePath, schemaPath: "#/oneOf", keyword: "oneOf", params: { passingSchemas: passing0 }, message: "must match exactly one schema in oneOf" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if (data && "object" == typeof data && !Array.isArray(data))
    void 0 !== data.identities && (validate27(data.identities, { instancePath: instancePath + "/identities", parentData: data, parentDataProperty: "identities", rootData }) || (vErrors = null === vErrors ? validate27.errors : vErrors.concat(validate27.errors), errors = vErrors.length)), void 0 !== data.identityRefs && (validate31(data.identityRefs, { instancePath: instancePath + "/identityRefs", parentData: data, parentDataProperty: "identityRefs", rootData }) || (vErrors = null === vErrors ? validate31.errors : vErrors.concat(validate31.errors), errors = vErrors.length));
else {
    const err1 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate22.errors = vErrors, 0 === errors; }
const schema18 = { type: "string", enum: ["policy.linkerd.io/v1alpha1"] };
function validate44(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("policy.linkerd.io/v1alpha1" !== data) {
    const err1 = { instancePath, schemaPath: "#/enum", keyword: "enum", params: { allowedValues: schema18.enum }, message: "must be equal to one of the allowed values" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate44.errors = vErrors, 0 === errors; }
const schema19 = { type: "string", enum: ["MeshTLSAuthentication"] };
function validate46(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if ("string" != typeof data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "string" }, message: "must be string" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} if ("MeshTLSAuthentication" !== data) {
    const err1 = { instancePath, schemaPath: "#/enum", keyword: "enum", params: { allowedValues: schema19.enum }, message: "must be equal to one of the allowed values" };
    null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
} return validate46.errors = vErrors, 0 === errors; }
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = tslib_1.__importDefault(require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta"));
function validate49(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; return (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.default)(data, { instancePath, parentData, parentDataProperty, rootData }) || (vErrors = null === vErrors ? IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.default.errors : vErrors.concat(IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.default.errors), errors = vErrors.length), validate49.errors = vErrors, 0 === errors; }
function validate53(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (null !== data) {
    const err0 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "null" }, message: "must be null" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} return validate53.errors = vErrors, 0 === errors; }
function validate48(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; const _errs0 = errors; let valid0 = !1, passing0 = null; const _errs1 = errors; validate49(data, { instancePath, parentData, parentDataProperty, rootData }) || (vErrors = null === vErrors ? validate49.errors : vErrors.concat(validate49.errors), errors = vErrors.length), (_valid0 = _errs1 === errors) && (valid0 = !0, passing0 = 0); const _errs2 = errors; var _valid0; if (validate53(data, { instancePath, parentData, parentDataProperty, rootData }) || (vErrors = null === vErrors ? validate53.errors : vErrors.concat(validate53.errors), errors = vErrors.length), (_valid0 = _errs2 === errors) && valid0 ? (valid0 = !1, passing0 = [passing0, 1]) : _valid0 && (valid0 = !0, passing0 = 1), valid0)
    errors = _errs0, null !== vErrors && (_errs0 ? vErrors.length = _errs0 : vErrors = null);
else {
    const err0 = { instancePath, schemaPath: "#/oneOf", keyword: "oneOf", params: { passingSchemas: passing0 }, message: "must match exactly one schema in oneOf" };
    null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
} return validate48.errors = vErrors, 0 === errors; }
function validate21(data, { instancePath = "", parentData, parentDataProperty, rootData = data } = {}) { let vErrors = null, errors = 0; if (data && "object" == typeof data && !Array.isArray(data)) {
    if (void 0 === data.spec) {
        const err0 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "spec" }, message: "must have required property 'spec'" };
        null === vErrors ? vErrors = [err0] : vErrors.push(err0), errors++;
    }
    if (void 0 === data.apiVersion) {
        const err1 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "apiVersion" }, message: "must have required property 'apiVersion'" };
        null === vErrors ? vErrors = [err1] : vErrors.push(err1), errors++;
    }
    if (void 0 === data.kind) {
        const err2 = { instancePath, schemaPath: "#/required", keyword: "required", params: { missingProperty: "kind" }, message: "must have required property 'kind'" };
        null === vErrors ? vErrors = [err2] : vErrors.push(err2), errors++;
    }
    void 0 !== data.spec && (validate22(data.spec, { instancePath: instancePath + "/spec", parentData: data, parentDataProperty: "spec", rootData }) || (vErrors = null === vErrors ? validate22.errors : vErrors.concat(validate22.errors), errors = vErrors.length)), void 0 !== data.apiVersion && (validate44(data.apiVersion, { instancePath: instancePath + "/apiVersion", parentData: data, parentDataProperty: "apiVersion", rootData }) || (vErrors = null === vErrors ? validate44.errors : vErrors.concat(validate44.errors), errors = vErrors.length)), void 0 !== data.kind && (validate46(data.kind, { instancePath: instancePath + "/kind", parentData: data, parentDataProperty: "kind", rootData }) || (vErrors = null === vErrors ? validate46.errors : vErrors.concat(validate46.errors), errors = vErrors.length)), void 0 !== data.metadata && (validate48(data.metadata, { instancePath: instancePath + "/metadata", parentData: data, parentDataProperty: "metadata", rootData }) || (vErrors = null === vErrors ? validate48.errors : vErrors.concat(validate48.errors), errors = vErrors.length));
}
else {
    const err3 = { instancePath, schemaPath: "#/type", keyword: "type", params: { type: "object" }, message: "must be object" };
    null === vErrors ? vErrors = [err3] : vErrors.push(err3), errors++;
} return validate21.errors = vErrors, 0 === errors; }
